#include "precompile.h"
#include "moveableentity.h"
#include "room.h"

void MoveableEntity::TouchLayer0EntityList(std::function<void (Entity*, bool&)> func)
{
    room->grid_service->TouchLayer0EntityList(grid_list_, func);
}

void MoveableEntity::TouchLayer1EntityList(std::function<void (Entity*, bool&)> func)
{
    room->grid_service->TouchLayer1EntityList(room->GetRoomIdx(), grid_list_, func);
}

void MoveableEntity::TouchAllLayerEntityList(std::function<void (Entity*, bool&)> func)
{
    room->grid_service->TouchAllLayerEntityList(room->GetRoomIdx(), grid_list_, func);
}

void MoveableEntity::TouchAllLayerHumanList(std::function<void (Human*, bool&)> func)
{
    room->grid_service->TouchAllLayerHumanList(room->GetRoomIdx(), grid_list_, func);
}
