#pragma once

enum SocketFrom_e
{
    SF_VirtualClient,
};

enum InnerMesssage_e
{
    IM_VirtualClientDisconnect  = 100,
    IM_VirtualClientConnect,
    IM_PlayerOffline,
    IM_ExecGM,
    IM_DBSConnDisconnect,
    IM_BSConnDisconnect,
    IM_LoadConfig,
    IM_HttpResponse,
};

//网络处理对象
enum NetHandler_e
{
    HID_GSMgr,
};

enum PlayerState_e
{
    PS_None
};

enum VirtualItemId_e
{
    VID_Item_Gold = 50001,
    VID_Item_Exp = 50002,
    VID_Soul_Stone = 50018,
    VID_Pickaxe = 50019
};

enum SyncData_e
{
    SYNC_Data_Exp = 0,
};

enum DoorState_e
{
    DoorStateClose = 0,
    DoorStateOpen = 1
};

enum GasMode_e
{
    GasInactive = 0,
    GasWaiting = 1,
    GasMoving = 2,
    GasJump = 3
};

enum ActionType_e
{
    AT_None = 0,
    AT_Reload = 1,
    AT_UseItem = 2,
    AT_Relive = 3,
    AT_Rescue = 4
};

enum InventorySlot_e
{
    IS_9MM  = 0,
    IS_556MM  = 1,
    IS_762MM  = 2,
    IS_12GAUGE  = 3,
    IS_RPG  = 4,
    IS_FRAG  = 5,
    IS_SMOKE  = 6,
    IS_HEALTHKIT  = 7,
    IS_PAIN_KILLER  = 8,

    IS_1XSCOPE  = 12,
    IS_2XSCOPE  = 13,
    IS_4XSCOPE  = 14,
    IS_8XSCOPE  = 15,
    IS_15XSCOPE = 16,

    IS_END
};

enum SkillType_e
{
    ST_Hide = 1,
    ST_SummonHero = 2,
    ST_Accelerate = 3,
    ST_DamageAdd = 4,
    ST_DefAdd = 5,
    ST_RecoverHP = 6,
    ST_ReflectDamage = 7,
    ST_SelfDetonate = 8
};

enum SkillCond_e
{
    SC_Active = 1,
    SC_Passive = 2
};

enum VirtualWeapon_e
{
    VW_SafeArea = 9000000,
    VW_Spectate = 9000001,
    VW_SelfDetonate = 9000002,
    VW_Mine = 9000003,
};

enum VirtualPlayer_e
{
    VP_SafeArea = 9000000,
    VP_Spectate = 9000001,
    VP_SelfDetonate = 9000002,
    VP_Mine = 9000003,
};

const char* const PROJ_NAME_FMT = "game%d_gameserver";
const char* const PROJ_ROOT_FMT = "/data/logs/%s";

const float TEN_W = 10000 * 10;

const int SYS_RESET_TIME = 2*60; //每日两点重置

const int DEF_WEAPON_ID = 12103;

const int SERVER_FRAME_RATE = 20;
const int SYNC_FRAME_RATE = 10;
const float FRAME_RATE_MS = 1000.0f / SERVER_FRAME_RATE;

const int MAX_WEAPON_NUM = 5;

const int GUN_SLOT1 = 1;
const int GUN_SLOT2 = 2;

const int FRAG_SLOT = 3;
const int SMOKE_SLOT = 4;

const int MAP_HEIGHT = 8192;
const int MAP_WIDTH = 8192;
const int MAP_CELL_WIDTH = 64 * 8;

const int DOOR_THING_ID = 61701;
